import EntityFormTemplate from 'model/EntityFormTemplate';

const OPENSTACK_SERVER_TEMPLATE: EntityFormTemplate[] = [
  {
    cloudServiceProvider: 'openstack',
    entityName: 'server_template',
    actionType: 'create',
    entityRecords: [
      {
        type: 'panel',
        panelName: 'Instance',
        keyValueRecords: [
          { type: 'default', labelName: 'Name', name: 'name', defaultValue: '', id: 'edit-name', class: 'form-item-name' },
          { type: 'textarea', labelName: 'Description', name: 'description', defaultValue: '', id: 'edit-description', class: 'form-item-description' },
          {
            type: 'join', labelName: 'Flavor', name: 'field_instance_type', info: {
              entityTypeId: 'openstack_flavor',
              keyColumn: 'name',
            }, defaultValue: '', required: true
          },
          {
            type: 'boolean', labelName: 'Test only', name: 'field_test_only',
            defaultValue: false, id: 'edit-field-test-only-value', class: 'form-item-field-test-only-value'
          },
        ]
      },
      {
        type: 'panel',
        panelName: 'Image',
        keyValueRecords: [
          {
            type: 'select', labelName: 'Image ID', name: 'field_openstack_image_id',
            url: '/cloud_dashboard/openstack/{cloud_context}/cloud_launch_template/image_options',
            defaultValue: '', required: true
          },
        ]
      },
      {
        type: 'panel',
        panelName: 'Network',
        keyValueRecords: [
          {
            type: 'select', labelName: 'Availability Zone', name: 'field_os_availability_zone',
            url: '/cloud_dashboard/openstack/{cloud_context}/availability_zones',
            defaultValue: '', required: true
          },
          {
            type: 'multi-select', labelName: 'Security groups', name: 'security_groups',
            url: '/cloud_dashboard/openstack/{cloud_context}/security_group_options',
            defaultValue: [],
            required: true
          },
          // TODO: Update defaultValue
          {
            type: 'join', labelName: 'SSH key', name: 'ssh_key', info: {
              entityTypeId: 'openstack_key_pair',
              keyColumn: 'key_pair_name',
              label: '{key_pair_name}'
            },
            defaultValue: '',
            required: true
          },
          {
            type: 'select', labelName: 'Network interface', name: 'network_id',
            url: '/cloud_dashboard/openstack/{cloud_context}/network_options',
            defaultValue: '',
          },
        ]
      },
      {
        type: 'panel',
        panelName: 'Server group',
        keyValueRecords: [
          {
            type: 'select', labelName: 'Server group name', name: 'field_openstack_server_group',
            url: '/cloud_dashboard/openstack/{cloud_context}/server_group_options',
            defaultValue: '',
          },
        ]
      },
      {
        type: 'panel',
        panelName: 'Tags',
        keyValueRecords: [
          {
            type: 'key-value', labelName: 'Tags', name: 'field_tags',
            defaultValue: []
          },
        ]
      },
      {
        type: 'panel',
        panelName: 'Others',
        keyValueRecords: [
          {
            type: 'textarea', labelName: 'Revision log message', name: 'revision_log_message',
            defaultValue: ''
          },
        ]
      },
    ]
  }
];

export default OPENSTACK_SERVER_TEMPLATE;
